/**
 this class is purely to make GAME look neater
 (note the g. infront of everything)
 */
class Events {
  void startGame() {
    g.shapeX = 5;
    g.shapeY = -1;
    g.s.newShape();
    g.s.newShape();
    g.toggleShape();
    g.gameStarted = true;
  }

  void dropDown() {
    g.toggleShape();
    g.shapeY += 1;
    g.replicaUpdate(1);
    if(GameLogic.shapeTestCollide(g.s.SHAPE)) {
      g.landed = true;
      g.shapeY -= 1;
    }
    g.toggleShape();
  }

  void newShape() { //if there is a collision on spawning a new shape, you lose!
    g.shapeX = 5;
    g.shapeY = -1;
    g.s.newShape();
    g.landed = false;
    g.replicaUpdate(1);
    if (GameLogic.shapeTestCollide(g.s.SHAPE)) {
      endGame();
    }
    g.toggleShape();
  }

  void endGame() {
    noLoop();
    g.gameEnded = true;
    fill(0,0,0);
    rect(0,0,width,height);

    textFont(fancyFont,(width/6));
    fill(255,255,255);
    textAlign(CENTER);
    text("GAME OVER", (width/2), (height/2)-(1*cellLength));
    
    textFont(fancyFont,(width/15));
    fill(255,255,255);
    textAlign(LEFT);
    text(g.lineCounter, (width/2), (height/2)+(1*cellLength));

    textFont(fancyFont,(width/15));
    fill(255,255,255);
    textAlign(RIGHT);
    text("Lines:", (width/2)-(0.2*cellLength), (height/2)+(1*cellLength));

    /**potential restart here
     if(key=='r'){
     g.gameStarted = false;
     g.b.resetBoard();
     gameGenerations = 0;
     loop();
     }
     */
  }

  void completedLines() {
    boolean rowTrue; //assume row complete
    for(int y=1; y<21; ++y) {
      rowTrue = true;
      for(int x=2; x<12; ++x) {
        if(!(g.b.getCell(x,y)))
          rowTrue = false;
      }
      if(rowTrue) {
        for(int z=2; z<12;++z) { //toggle completed row away
          g.b.toggleCell(z,y);
        }
        
        for(int c=y; c>0; --c){
          for(int x=2; x<12; ++x) {
            g.b.cell[x][c] = g.b.cell[x][c-1];
          }
        }
        g.lineCounter++;
      }
    }
  }
}

