class Shapes {
  boolean[][] SHAPE = new boolean[4][4]; //to load from every time, into grid, & do checks
  boolean[][] nextShape = new boolean[4][4]; // SHAPE loads from this, and this uses makeShape();
  int shapeNum; // each shape has a corresponding shapeNum (load from array)
  int nextShapeNum;
  int rotation; // 0-3 , an int to add to shapeID number before loading
  
  void update(){
    SHAPE = loadSHAPE(shapeNum + rotation);
  }
  
  void newShape(){
    shapeNum = nextShapeNum;
    SHAPE = nextShape;
    makeShape();
    nextShape = loadSHAPE(nextShapeNum);
  }
  
  void rotateRight(){
    if(rotation <= 0)
      rotation = 3;
    else
      rotation -= 1;
  }
  
  void rotateLeft(){
    if(rotation >= 3)
      rotation = 0;
    else
      rotation += 1;
  }
  
  void makeShape(){
    rotation = 0;
    int x = int(random(7));
    switch (x) {
      case 0:  nextShapeNum = 0; break;
      case 1:  nextShapeNum = 4; break;
      case 2:  nextShapeNum = 8; break;
      case 3:  nextShapeNum = 12; break;
      case 4:  nextShapeNum = 16; break;
      case 5:  nextShapeNum = 20; break;
      case 6:  nextShapeNum = 24; break;
      default: System.out.println("error makeShape();");
    }
  }
  
  boolean[][] loadSHAPE(int shapeID){
    String shapeString;
    boolean[][] returnMe = new boolean[4][4];
    switch (shapeID) {
      case 0:  shapeString = "0000011001100000"; break; //O0
      case 1:  shapeString = "0000011001100000"; break; //O1
      case 2:  shapeString = "0000011001100000"; break; //O2
      case 3:  shapeString = "0000011001100000"; break; //O3
      case 4:  shapeString = "0000111100000000"; break; //I0
      case 5:  shapeString = "0010001000100010"; break; //I1
      case 6:  shapeString = "0000111100000000"; break; //I2
      case 7:  shapeString = "0010001000100010"; break; //I3
      case 8:  shapeString = "0000001101100000"; break; //S0
      case 9:  shapeString = "0010001100010000"; break; //S1
      case 10:  shapeString = "0000001101100000"; break; //S2
      case 11:  shapeString = "0010001100010000"; break; //S3
      case 12:  shapeString = "0000011000110000"; break; //Z0
      case 13:  shapeString = "0001001100100000"; break; //Z1
      case 14:  shapeString = "0000011000110000"; break; //Z2
      case 15:  shapeString = "0001001100100000"; break; //Z3
      case 16:  shapeString = "0000011101000000"; break; //L0
      case 17:  shapeString = "0010001000110000"; break; //L1
      case 18:  shapeString = "0001011100000000"; break; //L2
      case 19:  shapeString = "0110001000100000"; break; //L3
      case 20:  shapeString = "0000011100010000"; break; //J0
      case 21:  shapeString = "0011001000100000"; break; //J1
      case 22:  shapeString = "0100011100000000"; break; //J2
      case 23:  shapeString = "0010001001100000"; break; //J3
      case 24:  shapeString = "0000011100100000"; break; //T0
      case 25:  shapeString = "0010001100100000"; break; //T1
      case 26:  shapeString = "0010011100000000"; break; //T2
      case 27:  shapeString = "0010011000100000"; break; //T3
      default: shapeString = "majorErrorOccured"; break;
    }
    int counter = 0;
    char[] shapeStringArray = shapeString.toCharArray();
    for(int y=0; y<4; ++y){
      for(int x=0; x<4; ++x){
        if(shapeStringArray[counter] == '1')
          returnMe[x][y] = true;
        else
          returnMe[x][y] = false;
        counter++;
      }
    }
    return returnMe;
  }
  
  Shapes(){
    for(int y=0; y<4; ++y){
      for(int x=0; x<4; ++x){
        SHAPE[x][y] = false;
        nextShape[x][y] = false;
      }
    }
  }
}
